% Num. Math. - FS 2014 - Serie 12 Uebung 1 - FFT Interpolation


function [ck]=s12_1
clear all

N=20;
%N=50;
m=5;
M=N*2^m;
 
x_k=2*pi/N*[0:N-1];
f_k=f(x_k); 

% Plotten der diskreten Funktionswerte 
clf;
plot(x_k,f_k,'rd','Markersize',7,'linewidth', 2);
hold on;

%Berechnen der komplexen Koeffizienten 
ck=fft(f_k/N);

% Plot: Einfuegen von M-N Nullen
c_star=[ck(1:floor(N/2)),zeros(1,M-N),ck(floor(N/2)+1:end)];
% Auswertung des trigonometrischen Polynoms auf feinem Gitter
x_star=2*pi/M*[0:M-1];
f_star=M*ifft(c_star);
plot(x_star,real(f_star), 'linewidth', 2);

% Exakt f:
fplot(@(x) f(x), [x_star(1),x_star(end)],'k');    
hold off;
end



function [y]=f(x)
y=sin(4*x).^2;

% y=sin(6*x).^2;
% y=exp(x)+exp(2*pi-x);
% y=(x).^2+(x-2*pi).^2;

% Bump function f in C^infinity(R):
% y=exp(-1./(1-(x/pi-1).^2));

% % Continuous functions with discontinuous derivatives:
% y=abs(sin(3*x));
% y=max(pi/2-abs(x-pi/2), pi/2-abs(x-3*pi/2));

% % Discontinuous function, try with high N (Gibbs phenomenon):
% y = floor(sin(2*x));

end
